<template>
    <div class="shopStore">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">门店管理</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getShopStoreList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="storeName" label="门店"></el-table-column>
                    <el-table-column prop="personCharge" label="负责人"></el-table-column>
                    <el-table-column prop="telephoneNumber" label="负责人电话"></el-table-column>
                    <el-table-column prop="storeAddress" label="门店地址"></el-table-column>
                    <el-table-column prop="remarks" label="备注"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addShopStore" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="门店名称">
                            <el-input v-model="formData.storeName"></el-input>
                        </el-form-item>

                        <el-form-item label="负责人">
                            <el-input v-model="formData.personCharge"></el-input>
                        </el-form-item>

                        <el-form-item label="负责人电话">
                            <el-input v-model="formData.telephoneNumber"></el-input>
                        </el-form-item>

                        <el-form-item label="门店地址">
                            <el-input v-model="formData.storeAddress"></el-input>
                        </el-form-item>

                        <el-form-item label="备注">
                            <el-input v-model="formData.remarks"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addShopStore')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqShopStoreList,
    reqAddShopStore,
    reqUpdateShopStore,
    reqDelShopStore
} from "@/api/storeTransportation.js";

const pageSize = 10;
const rules = {};

export default {
    name: "shopStore",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                storeName: "北京一号店铺",
                personCharge: "李小红",
                telephoneNumber: "13699637894",
                storeAddress: "北京市海淀区西二旗",
                remarks: "备注"
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 门店管理列表
        this.getShopStoreList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddShopStore(this.formData)
                            .then(res => {
                                // 门店管理列表
                                this.getShopStoreList();
                                // this.$message.success("添加成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateShopStore(this.formData)
                            .then(res => {
                                // 门店管理列表
                                this.getShopStoreList();
                                // this.$message.success("编辑成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 门店管理列表
        getShopStoreList() {
            reqShopStoreList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelShopStore(row.id)
                .then(res => {
                    console.log(res);
                    // 门店管理列表
                    this.getShopStoreList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 门店管理列表
            this.getShopStoreList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>